buildgcc: Fix typo in check for failed iasl build
[coreboot.git] / util / crossgcc / buildgcc
1 #!/bin/bash
2 #
3 # Copyright (C) 2008-2010 by coresystems GmbH
4 # written by Patrick Georgi <patrick.georgi@coresystems.de> and
5 #            Stefan Reinauer <stefan.reinauer@coresystems.de>
6 #
7 # Copyright (C) 2011 by Sage Electronic Engineering
8 #
9 # This program is free software; you can redistribute it and/or modify
10 # it under the terms of the GNU General Public License as published by
11 # the Free Software Foundation; version 2 of the License.
12 #
13 # This program is distributed in the hope that it will be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write to the Free Software
20 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
21 #
22
23 CROSSGCC_DATE="August 8th, 2011"
24 CROSSGCC_VERSION="1.04"
25
26 # default settings
27 TARGETDIR=`pwd`/xgcc
28 TARGETARCH=i386-elf
29 DESTDIR=
30
31 # version numbers
32 GMP_VERSION=5.0.1
33 MPFR_VERSION=3.0.0
34 MPC_VERSION=0.8.2
35 LIBELF_VERSION=0.8.13
36 GCC_VERSION=4.5.2
37 BINUTILS_VERSION=2.20.1
38 GDB_VERSION=7.2
39 W32API_VERSION=3.17-2
40 W32API_VERSION_SHORT=3.17
41 MINGWRT_VERSION=3.18
42 IASL_VERSION=20110623
43
44 # archive locations
45 GMP_ARCHIVE="ftp://ftp.gmplib.org/pub/gmp-${GMP_VERSION}/gmp-${GMP_VERSION}.tar.bz2"
46 MPFR_ARCHIVE="http://www.mpfr.org/mpfr-${MPFR_VERSION}/mpfr-${MPFR_VERSION}.tar.bz2"
47 MPC_ARCHIVE="http://www.multiprecision.org/mpc/download/mpc-${MPC_VERSION}.tar.gz"
48 LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
49 GCC_ARCHIVE="ftp://ftp.fu-berlin.de/unix/languages/gcc/releases/gcc-${GCC_VERSION}/gcc-core-${GCC_VERSION}.tar.bz2"
50 BINUTILS_ARCHIVE="http://ftp.gnu.org/gnu/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
51 GDB_ARCHIVE="http://ftp.gnu.org/gnu/gdb/gdb-${GDB_VERSION}.tar.bz2"
52 W32API_ARCHIVE="http://downloads.sourceforge.net/project/mingw/MinGW/BaseSystem/RuntimeLibrary/Win32-API/w32api-${W32API_VERSION_SHORT}/w32api-${W32API_VERSION}-mingw32-src.tar.lzma"
53 MINGWRT_ARCHIVE="http://downloads.sourceforge.net/project/mingw/MinGW/BaseSystem/RuntimeLibrary/MinGW-RT/mingwrt-${MINGWRT_VERSION}/mingwrt-${MINGWRT_VERSION}-mingw32-src.tar.gz"
54 IASL_ARCHIVE="http://www.acpica.org/download/acpica-unix-${IASL_VERSION}.tar.gz"
55
56 GMP_DIR="gmp-${GMP_VERSION}"
57 MPFR_DIR="mpfr-${MPFR_VERSION}"
58 MPC_DIR="mpc-${MPC_VERSION}"
59 LIBELF_DIR="libelf-${LIBELF_VERSION}"
60 GCC_DIR="gcc-${GCC_VERSION}"
61 BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
62 GDB_DIR="gdb-${GDB_VERSION}"
63 W32API_DIR="w32api-${W32API_VERSION}-mingw32"
64 MINGWRT_DIR="mingwrt-${MINGWRT_VERSION}-mingw32"
65 IASL_DIR="acpica-unix-${IASL_VERSION}"
66
67 SAVETEMPS=0
68 SKIPGDB=0
69
70 red='\e[0;31m'
71 RED='\e[1;31m'
72 green='\e[0;32m'
73 GREEN='\e[1;32m'
74 blue='\e[0;34m'
75 BLUE='\e[1;34m'
76 cyan='\e[0;36m'
77 CYAN='\e[1;36m'
78 NC='\e[0m' # No Color
79
80 searchgnu()
81 {
82         # $1 short name
83         # result: GNU version of that tool on stdout
84         #         or no output if no GNU version was found
85         for i in "$1" "g$1" "gnu$1"; do
86                 if test -x "`which $i 2>/dev/null`"; then
87                         if test `$i --version 2>/dev/null |grep -c GNU` -gt 0; then
88                                 echo $i
89                                 return
90                         fi
91                 fi
92         done
93         printf "${RED}ERROR:${red} Missing toolchain: $1${NC}\n" >&2
94         exit 1
95 }
96
97 TAR=`searchgnu tar` || exit $?
98 PATCH=`searchgnu patch` || exit $?
99 MAKE=`searchgnu make` || exit $?
100
101 cleanup()
102 {
103         printf "Cleaning up temporary files... "
104         rm -rf build-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-* gdb-* w32api-* mingwrt-* acpica-*
105         printf "${green}ok${NC}\n"
106 }
107
108 myhelp()
109 {
110         printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-G]\n"
111         printf "       $0 [-V|--version]\n"
112         printf "       $0 [-h|--help]\n\n"
113
114         printf "Options:\n"
115         printf "    [-V|--version]                print version number and exit\n"
116         printf "    [-h|--help]                   print this help and exit\n"
117         printf "    [-c|--clean]                  remove temporary files before build\n"
118         printf "    [-t|--savetemps]              don't remove temporary files after build\n"
119         printf "    [-j|--jobs <num>]             run <num> jobs in parallel in make\n"
120         printf "    [-p|--platform <platform>]    target platform to build cross compiler for\n"
121         printf "                                  (defaults to $TARGETARCH)\n"
122         printf "    [-d|--directory <target dir>] target directory to install cross compiler to\n"
123         printf "                                  (defaults to $TARGETDIR)\n\n"
124         printf "    [-D|--destdir <dest dir>]     destination directory to install cross compiler to\n"
125         printf "                                  (for RPM builds, default unset)\n\n"
126         printf "    [-G|--skip-gdb]               don't build GNU debugger\n"
127 }
128
129 myversion()
130 {
131         # version tag is always printed, so just print the license here
132
133         cat << EOF
134 Copyright (C) 2008-2010 by coresystems GmbH
135 Copyright (C) 2011 by Sage Electronic Engineering
136
137 This program is free software; you can redistribute it and/or modify
138 it under the terms of the GNU General Public License as published by
139 the Free Software Foundation; version 2 of the License.
140
141 This program is distributed in the hope that it will be useful,
142 but WITHOUT ANY WARRANTY; without even the implied warranty of
143 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
144 GNU General Public License for more details.
145
146 EOF
147 }
148
149 printf "${blue}Welcome to the ${red}coresystems${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
150
151 # Look if we have getopt. If not, build it.
152 export PATH=$PATH:.
153 getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
154
155 # parse parameters.. try to find out whether we're running GNU getopt
156 getoptbrand="`getopt -V`"
157 if [ "${getoptbrand:0:6}" == "getopt" ]; then
158         # Detected GNU getopt that supports long options.
159         args=`getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb Vhcd:p:j:D:tG -- "$@"`
160         eval set "$args"
161 else
162         # Detected non-GNU getopt
163         args=`getopt Vhcd:p:j:D:tG $*`
164         set -- $args
165 fi
166
167 if [ $? != 0 ]; then
168         myhelp
169         exit 1
170 fi
171
172 while true ; do
173         case "$1" in
174                 -V|--version)   shift; myversion; exit 0;;
175                 -h|--help)      shift; myhelp; exit 0;;
176                 -c|--clean)     shift; cleanup;;
177                 -t|--savetemps) shift; SAVETEMPS=1;;
178                 -d|--directory) shift; TARGETDIR="$1"; shift;;
179                 -p|--platform)  shift; TARGETARCH="$1"; shift;;
180                 -D|--destdir)   shift; DESTDIR="$1"; shift;;
181                 -j|--jobs)      shift; JOBS="-j $1"; shift;;
182                 -G|--skip-gdb)  shift; SKIPGDB=1;;
183                 --)             shift; break;;
184                 -*)             printf "Invalid option\n\n"; myhelp; exit 1;;
185                 *)              break;;
186         esac
187 done
188
189 GDB_PACKAGE="GDB"
190 if [ $SKIPGDB -eq 1 ]; then
191         printf "Will skip GDB ... ${green}ok${NC}\n"
192         GDB_PACKAGE=""
193 fi
194
195 MINGW_ARCHIVES=""
196 if [ "$TARGETARCH" = "i386-mingw32" ]; then
197         MINGW_ARCHIVES="$W32API_ARCHIVE $MINGWRT_ARCHIVE"
198 fi
199
200 if [ ${GCC_VERSION} == "4.5.0" -o ${GCC_VERSION} == "4.6.0" ]; then
201   # coreboot does not like the GOLD linker
202   # USE_GOLD="--enable-gold"
203   USE_GOLD=""
204   GCC_OPTIONS="--enable-lto"
205 fi
206
207 if [ ${GCC_VERSION} == "4.6.0" ]; then
208   if [ ! -r tarballs/gcc-core-${GCC_VERSION}.tar.bz2 ]; then
209     printf "Pre-Release GCC ${GCC_VERSION}, checking out subversion trunk\n"
210     mkdir -p tarballs/.tmp
211     cd tarballs/.tmp
212     rm -rf gcc-${GCC_VERSION}
213     svn export -q svn://gcc.gnu.org/svn/gcc/trunk gcc-${GCC_VERSION}
214     printf "done. Now creating tar ball...\n"
215     tar cjf ../gcc-core-${GCC_VERSION}.tar.bz2 gcc-${GCC_VERSION}
216     printf "done. Now cleaning up...\n"
217     cd ..
218     rm -rf .tmp
219     cd ..
220     printf "done.\n"
221   fi
222 fi
223
224 printf "Downloading tar balls ... \n"
225 mkdir -p tarballs
226 for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $MINGW_ARCHIVES $IASL_ARCHIVE; do
227         FILE=`basename $ARCHIVE`
228         printf " * $FILE "
229         test -f tarballs/$FILE && printf "(cached)" || (
230                 printf "(downloading)"
231                 cd tarballs
232                 wget -q $ARCHIVE
233         )
234         test -f tarballs/$FILE || printf "\n${RED}Failed to download $FILE.${red}\n"
235         test -f tarballs/$FILE || exit 1
236         printf "\n"
237 done
238 printf "Downloaded tar balls ... "
239 printf "${green}ok${NC}\n"
240
241 MINGW_PACKAGES=""
242 if [ "$TARGETARCH" = "i386-mingw32" ]; then
243         MINGW_PACKAGES="W32API MINGWRT"
244 fi
245
246 printf "Unpacking and patching ... \n"
247 for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $GDB_PACKAGE $MINGW_PACKAGES IASL; do
248         archive=$PACKAGE"_ARCHIVE"
249         archive=${!archive}
250         dir=$PACKAGE"_DIR"
251         test -d ${!dir} || (
252                 printf " * `basename $archive`\n"
253                 FLAGS=zxf
254                 test ${archive:${#archive}-2:2} = "gz" && FLAGS=zxf
255                 test ${archive:${#archive}-3:3} = "bz2" && FLAGS=jxf
256                 test ${archive:${#archive}-4:4} = "lzma" && FLAGS="--lzma -xf"
257                 $TAR $FLAGS tarballs/`basename $archive`
258                 for patch in patches/${!dir}_*.patch; do
259                         test -r $patch || continue
260                         printf "   o `basename $patch`\n"
261                         $PATCH -s -N -p0 < `echo $patch`
262                 done
263         )
264 done
265 printf "Unpacked and patched ... "
266 printf "${green}ok${NC}\n"
267
268 if [ "$TARGETARCH" = "i386-mingw32" ]; then
269         mkdir -p $TARGETDIR/i386-mingw32/sys-include
270         mv $MINGWRT_DIR/include/* $W32API_DIR/include/* $TARGETDIR/i386-mingw32/sys-include
271 fi
272
273 if [ `uname` = "Darwin" ]; then
274         #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
275
276         # generally the OS X compiler can create x64 binaries.
277         # Per default it generated i386 binaries in 10.5 and x64
278         # binaries in 10.6 (even if the kernel is 32bit)
279         # For some weird reason, 10.5 autodetects an ABI=64 though
280         # so we're setting the ABI explicitly here.
281         if [ `sysctl -n hw.optional.x86_64` -eq 1 ]; then
282                 OPTIONS="ABI=64"
283         else
284                 OPTIONS="ABI=32"
285         fi
286         # old check:
287         #OPTIONS="ABI=32"
288         #touch .architecture_check.c
289         #gcc .architecture_check.c -c -o .architecture_check.o
290         #ARCH=`file .architecture_check.o |cut -f5 -d\ `
291         #test  "$ARCH" = "x86_64" && OPTIONS="ABI=64"
292         #rm .architecture_check.c .architecture_check.o
293 fi
294
295 mkdir -p build-gmp build-mpfr build-mpc build-libelf build-binutils build-gcc
296 if [ $SKIPGDB -eq 0 ]; then
297         mkdir -p build-gdb
298 fi
299 if [ -f build-gmp/.success ]; then
300         printf "Skipping GMP as it is already built\n"
301 else
302 printf "Building GMP ${GMP_VERSION} ... "
303 (
304         cd build-gmp
305         rm -f .failed
306         ../${GMP_DIR}/configure --disable-shared --prefix=$TARGETDIR $OPTIONS \
307                 || touch .failed
308         $MAKE $JOBS || touch .failed
309         $MAKE install DESTDIR=$DESTDIR || touch .failed
310         if [ ! -f .failed ]; then touch .success; fi
311 ) &> build-gmp/crossgcc-build.log
312 test -r build-gmp/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
313 test -r build-gmp/.failed && exit 1
314 fi
315
316 #if [ "$DESTDIR" != "" -a ! -x $TARGETDIR ]; then
317 #       # create compat link
318 #       ln -s $DESTDIR$TARGETDIR $TARGETDIR
319 #fi
320
321 # Now set CFLAGS to match GMP CFLAGS.
322 HOSTCFLAGS=`grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2`
323
324 if [ -f build-mpfr/.success ]; then
325         printf "Skipping MPFR as it is already built\n"
326 else
327 printf "Building MPFR ${MPFR_VERSION} ... "
328 (
329         test `uname` = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
330         cd build-mpfr
331         rm -f .failed
332         ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
333                 --infodir=$TARGETDIR/info \
334                 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || touch .failed
335         $MAKE $JOBS || touch .failed
336         $MAKE install DESTDIR=$DESTDIR || touch .failed
337
338         # work around build problem of libgmp.la
339         if [ "$DESTDIR" != "" ]; then
340             perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
341         fi
342
343         if [ ! -f .failed ]; then touch .success; fi
344 ) &> build-mpfr/crossgcc-build.log
345 test -r build-mpfr/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
346 test -r build-mpfr/.failed && exit 1
347 fi
348
349 if [ -f build-mpc/.success ]; then
350         printf "Skipping MPC as it is already built\n"
351 else
352 printf "Building MPC ${MPC_VERSION} ... "
353 (
354         #test `uname` = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
355         cd build-mpc
356         rm -f .failed
357         ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
358                 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
359                 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || touch .failed
360         $MAKE $JOBS || touch .failed
361         $MAKE install DESTDIR=$DESTDIR || touch .failed
362
363         if [ ! -f .failed ]; then touch .success; fi
364 ) &> build-mpc/crossgcc-build.log
365 test -r build-mpc/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
366 test -r build-mpc/.failed && exit 1
367 fi
368
369 if [ -f build-libelf/.success ]; then
370         printf "Skipping libelf as it is already built\n"
371 else
372 printf "Building libelf ${LIBELF_VERSION} ... "
373 (
374         cd build-libelf
375         rm -f .failed
376         echo "$HOSTCFLAGS"
377         CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
378                 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
379         $MAKE $JOBS || touch .failed
380         $MAKE install DESTDIR=$DESTDIR || touch .failed
381
382         if [ ! -f .failed ]; then touch .success; fi
383 ) &> build-libelf/crossgcc-build.log
384 test -r build-libelf/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
385 test -r build-libelf/.failed && exit 1
386 fi
387
388 if [ -f build-binutils/.success ]; then
389         printf "Skipping binutils as it is already built\n"
390 else
391 printf "Building binutils ${BINUTILS_VERSION} ... "
392 (
393         cd build-binutils
394         rm -f .failed
395         ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR --target=${TARGETARCH} \
396                 --disable-werror --disable-nls $USE_GOLD \
397                 CFLAGS="$HOSTCFLAGS" || touch .failed
398         $MAKE $JOBS || touch .failed
399         $MAKE install DESTDIR=$DESTDIR || touch .failed
400         if [ ! -f .failed ]; then touch .success; fi
401 ) &> build-binutils/crossgcc-build.log
402 test -r build-binutils/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
403 test -r build-binutils/.failed && exit 1
404 fi
405
406 if [ -f build-gcc/.success ]; then
407         printf "Skipping GCC as it is already built\n"
408 else
409 printf "Building GCC ${GCC_VERSION} ... "
410 (
411         cd build-gcc
412         export PATH=$PATH:$DESTDIR$TARGETDIR/bin
413         rm -f .failed
414         # GCC does not honour HOSTCFLAGS at all. CFLAGS are used for
415         # both target and host object files. This is pretty misdesigned.
416         # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
417         # but it does not seem to work properly. At least the host library
418         # libiberty is not compiled with CFLAGS_FOR_BUILD.
419         CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
420                 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
421                 --target=${TARGETARCH} --disable-werror --disable-shared \
422                 --disable-libssp --disable-bootstrap --disable-nls \
423                 $GCC_OPTIONS --enable-languages="c" $USE_GOLD \
424                 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
425                 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
426                 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
427                 || touch .failed
428         $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" || touch .failed
429         $MAKE install DESTDIR=$DESTDIR || touch .failed
430         if [ ! -f .failed ]; then touch .success; fi
431 ) &> build-gcc/crossgcc-build.log
432 test -r build-gcc/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
433 test -r build-gcc/.failed && exit 1
434 fi
435
436 if [ -f build-gdb/.success ]; then
437         printf "Skipping GDB as it is already built\n"
438 elif [ $SKIPGDB -eq 1 ]; then
439         printf "Skipping GDB as requested by command line\n"
440 else
441 printf "Building GDB ${GDB_VERSION} ... "
442 (
443         cd build-gdb
444         export PATH=$PATH:$DESTDIR$TARGETDIR/bin
445         rm -f .failed
446         CFLAGS="$HOSTCFLAGS" ../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR --target=${TARGETARCH} \
447                 --without-python --disable-werror --disable-nls
448         $MAKE $JOBS || touch .failed
449         $MAKE install DESTDIR=$DESTDIR || touch .failed
450         if [ ! -f .failed ]; then touch .success; fi
451 ) &> build-gdb/crossgcc-build.log
452 test -r build-gdb/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
453 test -r build-gdb/.failed && exit 1
454 fi
455
456 if [ -f $IASL_DIR/compiler/.success ]; then
457         printf "Skipping IASL as it is already built\n"
458 else
459 printf "Building IASL ${IASL_VERSION} ... "
460 (
461         cd $IASL_DIR/compiler
462         export PATH=$PATH:$DESTDIR$TARGETDIR/bin
463         rm -f .failed
464         CFLAGS="$HOSTCFLAGS"
465         $MAKE || touch .failed
466         rm -f $DESTDIR$TARGETDIR/bin/iasl || touch .failed
467         cp iasl $DESTDIR$TARGETDIR/bin || touch .failed
468         if [ ! -f .failed ]; then touch .success; fi
469 ) &> $IASL_DIR/compiler/crossgcc-build.log
470 test -r $IASL_DIR/compiler/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
471 test -r $IASL_DIR/compiler/.failed && exit 1
472 fi
473
474 if [ $SAVETEMPS -eq 0 ]; then
475         printf "Cleaning up... "
476         rm -rf ${GMP_DIR} build-gmp
477         rm -rf ${MPFR_DIR} build-mpfr
478         rm -rf ${MPC_DIR} build-mpc
479         rm -rf ${LIBELF_DIR} build-libelf
480         rm -rf ${BINUTILS_DIR} build-binutils
481         rm -rf ${GCC_DIR} build-gcc
482         rm -rf ${GDB_DIR} build-gdb
483         rm -rf ${IASL_DIR}
484         printf "${green}ok${NC}\n"
485 else
486         printf "Leaving temporary files around... ${green}ok${NC}\n"
487 fi
488
489 printf "\n${green}You can now run your $TARGETARCH cross toolchain from $TARGETDIR.${NC}\n"
490
491